using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.Threading;

namespace EbiSoft.Library.Mobile
{
    /// <summary>
    /// _CAAbvڑǗ܂
    /// </summary>
    public partial class ConnectionManager
    {
        #region P/Invoke 錾

        const int S_OK = 0;
        const uint CONNMGR_PARAM_GUIDDESTNET = 0x1;
        const uint CONNMGR_FLAG_PROXY_HTTP = 0x1;
        const uint CONNMGR_PRIORITY_USERINTERACTIVE = 0x08000;
        const uint INFINITE = 0xffffffff;
        const uint CONNMGR_STATUS_CONNECTED = 0x10;

        [DllImport("cellcore.dll")]
        private static extern int ConnMgrMapURL(string pwszURL, ref Guid pguid, IntPtr pdwIndex);

        [DllImport("cellcore.dll")]
        private static extern int ConnMgrEstablishConnectionSync(ref ConnectionInfo ci, ref IntPtr phConnection, uint dwTimeout, ref uint pdwStatus);

        [DllImport("cellcore.dll")]
        private static extern IntPtr ConnMgrApiReadyEvent();

        [DllImport("cellcore.dll")]
        private static extern int ConnMgrReleaseConnection(IntPtr hConnection, int bCache);

        [DllImport("coredll.dll")]
        private static extern int CloseHandle(IntPtr hObject);

        #endregion
        
        static int m_cacheLength = 0;

        static Dictionary<string, IntPtr> ht = new Dictionary<string, IntPtr>();

        /// <summary>
        /// X^eBbN RXgN^
        /// </summary>
        static ConnectionManager()
        {
            ManualResetEvent mre = new ManualResetEvent(false);
            mre.Handle = ConnMgrApiReadyEvent();
            mre.WaitOne();
            CloseHandle(mre.Handle);
        }

        /// <summary>
        /// fXgN^
        /// </summary>
        ~ConnectionManager()
        {
            ReleaseAll();
        }

        /// <summary>
        /// w肳ꂽꏊɐڑł悤lbg[NoH̊mۂs
        /// </summary>
        /// <param name="url">ڑURL</param>
        /// <returns> true</returns>
        public static bool Connection(Uri url)
        {
            return Connection(url.ToString(), false);
        }

        /// <summary>
        /// w肳ꂽꏊɐڑł悤lbg[NoH̊mۂs
        /// </summary>
        /// <param name="url">ڑURL</param>
        /// <returns> true</returns>
        public static bool Connection(string url)
        {
            return Connection(url, false);
        }

        /// <summary>
        /// w肳ꂽꏊɐڑł悤lbg[NoH̊mۂs
        /// </summary>
        /// <param name="url">ڑURL</param>
        /// <param name="disabled">ڑԂ̊mFŐڑsȂȂ true</param>
        /// <returns> true</returns>
        public static bool Connection(Uri url, bool disabled)
        {
            return Connection(url.ToString(), disabled);
        }


        /// <summary>
        /// w肳ꂽꏊɐڑł悤lbg[NoH̊mۂs
        /// </summary>
        /// <param name="urlStr">ڑURL</param>
        /// <param name="disabled">ڑԂ̊mFŐڑsȂȂ true</param>
        /// <returns> true</returns>
        public static bool Connection(string urlStr, bool disabled)
        {
            ConnectionInfo ci = new ConnectionInfo();
            IntPtr phConnection = IntPtr.Zero;
            uint status = 0;

            if (ht.ContainsKey(urlStr))
                return true;

            if (ConnMgrMapURL(urlStr, ref ci.guidDestNet, IntPtr.Zero) != S_OK)
                return false;

            ci.cbSize = (uint)Marshal.SizeOf(ci);
            ci.dwParams = CONNMGR_PARAM_GUIDDESTNET;
            ci.dwFlags = CONNMGR_FLAG_PROXY_HTTP;
            ci.dwPriority = CONNMGR_PRIORITY_USERINTERACTIVE;
            ci.bExclusive = 0;
            ci.hWnd = IntPtr.Zero;
            ci.uMsg = 0;
            ci.lParam = 0;

            if (disabled)
            {
                ci.bDisabled = 1;
            }
            else
            {
                ci.bDisabled = 0;
            }

            int hr = ConnMgrEstablishConnectionSync(ref ci, ref phConnection, INFINITE, ref status);
            if (hr == S_OK)
            {
                lock (ht)
                {
                    ht[urlStr] = phConnection;
                }
                if (status == CONNMGR_STATUS_CONNECTED)
                {
                    System.Diagnostics.Debug.WriteLine("ConnMgrEstablishConnectionSync OK");
                    return true;
                }
                else
                {
                    System.Diagnostics.Debug.WriteLine("ConnMgrEstablishConnectionSync NG:" + status.ToString());
                    return false;
                }
            }
            else
            {
                System.Diagnostics.Debug.WriteLine("ConnMgrEstablishConnectionSync ERROR:0x" + hr.ToString("X"));
                return false;
            }
        }

        /// <summary>
        /// w肳ꂽURLւ̐ڑ܂
        /// </summary>
        public static bool Release(string urlStr, bool removeNode)
        {
            bool res = true;
            lock (ht)
            {
                if (!ht.ContainsKey(urlStr))
                {
                    return true;
                }
                if (ConnMgrReleaseConnection(ht[urlStr], m_cacheLength) != S_OK)
                {
                    res = false;
                }
                CloseHandle(ht[urlStr]);
                if (removeNode)
                {
                    ht.Remove(urlStr);
                }
            }
            return res;
        }

        /// <summary>
        /// ڑ[X܂
        /// </summary>
        public static void ReleaseAll()
        {
            ReleaseAll(false);
        }

        /// <summary>
        /// ڑ[X܂
        /// </summary>
        /// <param name="removeNode">m[h菜ǂ</param>
        public static void ReleaseAll(bool removeNode)
        {
            string[] keys = new string[ht.Keys.Count];
            ht.Keys.CopyTo(keys, 0);

            foreach (string key in keys)
            {
                Release(key, removeNode);
            }
            ht.Clear();
        }

        /// <summary>
        /// w肳ꂽURLւ̌oHؒf܂
        /// </summary>
        /// <param name="url">ؒfURL</param>
        public static void Disconnect(Uri url)
        {
            Disconnect(url.ToString());
        }

        /// <summary>
        /// w肳ꂽURLւ̌oHؒf܂
        /// </summary>
        /// <param name="url">ؒfURL</param>
        public static void Disconnect(string url)
        {
            // LbVݒȂɂ
            int cacheLengthBackup = m_cacheLength;
            m_cacheLength = 0;

            // ؒf
            Connection(url, true);
            Release(url, true);

            // LbVݒ߂
            m_cacheLength = cacheLengthBackup;
        }

        /// <summary>
        /// LbV钷
        /// </summary>
        public static int ConnectionCacheLength
        {
            get { return m_cacheLength; }
            set
            {
                lock (ht)
                {
                    m_cacheLength = value;
                }
            }
        }

        [StructLayout(LayoutKind.Sequential)]
        internal struct ConnectionInfo
        {
            public uint cbSize;
            public uint dwParams;
            public uint dwFlags;
            public uint dwPriority;
            public int bExclusive;
            public int bDisabled;
            public Guid guidDestNet;
            public IntPtr hWnd;
            public uint uMsg;
            public uint lParam;
            public uint ulMaxCost;
            public uint ulMinRcvBw;
            public uint ulMaxConnLatency;
        }
    }
}
