using System;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.IO;
using System.Threading;
using EbiSoft.Library.Mobile;

namespace EbiSoft.ZeroProxy.Proxy
{
    public sealed class ProxyServer : IDisposable
    {
        Thread            listenThread;   // ҂󂯃Xbh
        TcpListener       listener;       // ҂󂯃\Pbg
        ProxyConnection[] connectionList; // ڑXg
        IPEndPoint        bindEndPoint;   // oCh

        /// <summary>
        /// RXgN^
        /// </summary>
        public ProxyServer(IPEndPoint endPoint)
        {
            listenThread = null;
            listener = null;
            connectionList = null;
            bindEndPoint = endPoint;
            ConnectionManager.ConnectionCacheLength = 1;
        }

        /// <summary>
        /// T[o[N
        /// </summary>
        public void Start()
        {
            // Ɏ~߂Ă
            Stop();

            // ڑXg̏
            connectionList = new ProxyConnection[MaxConnections];

            // XiN
            listener = new TcpListener(bindEndPoint);
            listener.Start();

            // XbhN
            listenThread = new Thread(new ThreadStart(ListenThreadAction));
            listenThread.IsBackground = true;
            listenThread.Name = "ProxyServerThread";
            listenThread.Start();
        }

        /// <summary>
        /// T[o[~
        /// </summary>
        public void Stop()
        {
            if (listener != null) listener.Stop();
            if (listenThread != null) listenThread.Abort();
            if (connectionList != null)
            {
                for (int i = 0; i < connectionList.Length; i++)
                {
                    if ((connectionList[i] != null) && (connectionList[i].Active))
                    {
                        connectionList[i].Dispose();
                    }
                }
                connectionList = null;
            }
        }

        /// <summary>
        /// MXbh
        /// </summary>
        private void ListenThreadAction()
        {
            try
            {
                int freeSlotIndex;  // JXbgCfbNX

                while (true)
                {
                    // 󂫃XbgT
                    freeSlotIndex = -1;
                    for (int i = 0; i < connectionList.Length; i++)
                    {
                        // JXbg΂g
                        if ((connectionList[i] == null) || !connectionList[i].Active)
                        {
                            freeSlotIndex = i;
                            break;
                        }

                        // ^CAEgĂ狭ؒf
                        else if ((connectionList[i] != null) && ((Environment.TickCount - connectionList[i].LastCommunicated) > Timeout))
                        {
                            connectionList[i].Dispose();
                        }
                    }

                    // JXbgƂ̂݁A҂s
                    if (freeSlotIndex > -1)
                    {
                        // ڑ҂
                        Socket socket = listener.AcceptSocket();

                        // Vڑ쐬
                        connectionList[freeSlotIndex] = new ProxyConnection(this, socket);
                    }
                }
            }
            catch (InvalidOperationException)   // AcceptSocketɃXi~܂ƂƂ
            {
            }
            catch (ThreadAbortException)        // Xbh~ꂽƂ
            {
            }
            finally
            {
                try
                {
                    // Xi~
                    listener.Stop();
                }
                catch (SocketException) { }

                // MXbh
                listener = null;
                listenThread = null;
            }
        }

        #region IDisposable o

        public void Dispose()
        {
            throw new Exception("The method or operation is not implemented.");
        }

        #endregion

        #region vpeB

        /// <summary>
        /// őXbh
        /// </summary>
        public int MaxConnections
        {
            get { return m_maxConnections; }
            set { m_maxConnections = value; }
        }
        private int m_maxConnections = 20;

        /// <summary>
        /// ^CAEg(ms)
        /// </summary>
        public int Timeout
        {
            get { return m_timeout; }
            set { m_timeout = value; }
        }
        private int m_timeout = 60 * 1000;  // 1

        #endregion
    }
}
